"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOauthToken = void 0;
const netrc_parser_1 = __importDefault(require("netrc-parser"));
const gyuma_1 = require("gyuma");
const getOauthToken = async ({ domain, scope = 'k:app_settings:read', proxy, pfx, }) => {
    // プロキシサーバーの認証情報がnetrcにある場合は読み取る
    // 認証はオプションなので、認証情報が見つからなくても標準入力はさせない
    if (proxy instanceof Object && !proxy.auth) {
        netrc_parser_1.default.loadSync();
        const netrcProxyProps = netrc_parser_1.default.machines[proxy.hostname];
        if (netrcProxyProps) {
            proxy.auth = `${netrcProxyProps.login}:${netrcProxyProps.password}`;
        }
    }
    const token = await (0, gyuma_1.gyuma)({ domain, scope, proxy, pfx }, true);
    return token;
};
exports.getOauthToken = getOauthToken;
