#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./_common/util");
const generator_1 = __importDefault(require("./generator"));
const bundler_1 = __importDefault(require("./bundler"));
const dotenv_1 = require("dotenv");
(0, dotenv_1.config)();
const argv = (0, util_1.parseArgumentOptions)();
if (!argv._subCommand) {
    if (argv.version) {
        (0, util_1.showVersion)();
    }
    else if (argv.help) {
        (0, util_1.usageExit)(0);
    }
    else {
        (0, util_1.usageExit)(1);
    }
}
// TODO: --helpの扱いをうまくやる
if (['new', 'generate', 'g'].includes(argv._subCommand)) {
    (0, generator_1.default)(argv);
}
else {
    (0, bundler_1.default)(argv);
}
