"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const sao_1 = require("sao");
const path_1 = require("path");
const util_1 = require("../../_common/util");
const run = ({ templateDirRoot, goqooConfig, generatorName, appName }) => {
    const appsDir = (0, util_1.projectPath)('./src/apps');
    if (!(0, util_1.existsDirectory)(appsDir)) {
        console.error(`Not a directory: ${appsDir}`);
        process.exit(1);
    }
    // TODO: templateDirをユーザーが指定可能に
    const bundlerType = goqooConfig.bundlerType || 'default';
    const templateDir = (0, path_1.join)(templateDirRoot, bundlerType, 'src/apps', generatorName);
    if (!(0, util_1.existsDirectory)(templateDir)) {
        console.error(`Template not found: ${templateDir}`);
        process.exit(1);
    }
    const sao = new sao_1.SAO({
        generator: (0, path_1.resolve)(__dirname, './'),
        outDir: (0, path_1.join)(appsDir, appName),
        answers: { name: appName, templateDir },
    });
    sao.run().catch(sao_1.handleError);
};
exports.run = run;
