"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const util_1 = require("../_common/util");
const main = async (argv) => {
    const rawArgv = process.argv.slice(3);
    const templateDirRoot = (0, path_1.join)((0, path_1.dirname)(require.resolve('@goqoo/templates/package.json')), 'templates');
    if (argv._subCommand === 'new') {
        const [projectDir] = rawArgv;
        return Promise.resolve().then(() => __importStar(require('./new'))).then(({ run }) => run({ templateDirRoot, projectDir }));
    }
    const goqooConfig = (0, util_1.loadGoqooConfig)();
    const [generatorName, appName] = rawArgv;
    if (generatorName === 'dts') {
        return Promise.resolve().then(() => __importStar(require('./dts'))).then(({ run }) => run(goqooConfig));
    }
    if (!generatorName || !appName) {
        // TODO: ちゃんと関数化などする
        console.error(`usage: goqoo generate GENERATOR APP`);
        process.exit(1);
    }
    switch (generatorName) {
        case 'scaffold':
            // TODO: appとin-appの組み合わせ全部入り
            return Promise.resolve().then(() => __importStar(require('./scaffold'))).then(({ run }) => run({}));
        case 'app':
        case 'space':
        case 'portal':
            return Promise.resolve().then(() => __importStar(require('./app'))).then(({ run }) => run({ templateDirRoot, goqooConfig, generatorName, appName }));
        default:
            // event, customize-viewなど、既存アプリ内にgenerateするもの
            await Promise.resolve().then(() => __importStar(require('./in-app'))).then(({ run }) => run({ templateDirRoot, goqooConfig, generatorName, appName }));
    }
};
exports.default = async (argv) => {
    try {
        await main(argv);
    }
    catch (e) {
        console.error(e);
    }
};
