"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const sao_1 = require("sao");
const path_1 = require("path");
const util_1 = require("../../_common/util");
const run = ({ templateDirRoot, projectDir }) => {
    // TODO: templateDirをユーザーが指定可能に
    const templateDir = templateDirRoot;
    if (!(0, util_1.existsDirectory)(templateDir)) {
        console.error(`Template not found: ${templateDir}`);
        process.exit(1);
    }
    const sao = new sao_1.SAO({
        generator: (0, path_1.resolve)(__dirname, './'),
        outDir: projectDir,
        answers: { templateDir },
    });
    sao.run().catch(sao_1.handleError);
};
exports.run = run;
