"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.goqoo = void 0;
const luxon_1 = require("luxon");
const goqoo = (entryName, callback) => {
    if (!window.__goqoo__) {
        window.__goqoo__ = {};
    }
    if (!window.__devinfo__) {
        window.__devinfo__ = {};
    }
    if (!window.__goqoo__[entryName]) {
        window.__goqoo__[entryName] = true;
        window.__devinfo__[entryName] = {
            nodeEnv: process.env.BUILT_NODE_ENV,
            commitHash: process.env.COMMIT_HASH,
            builtAt: luxon_1.DateTime.fromISO(process.env.BUILT_AT).toString(),
        };
        callback();
    }
    else {
        console.warn(`Goqoo JS code "${entryName}" is already runnning. The second and subsequent codes will be skipped!`);
    }
};
exports.goqoo = goqoo;
